function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, Index, JoinColumn, Column, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { UserGroup } from "./user-group.js";
import { id } from "../id.js";
export let CallBlocking = class CallBlocking {
    id;
    createdAt;
    blockeeId;
    blockee;
    groupId;
    group;
    blockerId;
    blocker;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], CallBlocking.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The created date of the CallBlocking."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], CallBlocking.prototype, "createdAt", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "The call-blocked user ID."
    }),
    _ts_metadata("design:type", Object)
], CallBlocking.prototype, "blockeeId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], CallBlocking.prototype, "blockee", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], CallBlocking.prototype, "groupId", void 0);
_ts_decorate([
    ManyToOne((type)=>UserGroup, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], CallBlocking.prototype, "group", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "The call-blocking user ID."
    }),
    _ts_metadata("design:type", Object)
], CallBlocking.prototype, "blockerId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], CallBlocking.prototype, "blocker", void 0);
CallBlocking = _ts_decorate([
    Entity(),
    Index([
        "blockerId",
        "blockeeId"
    ], {
        unique: true,
        where: '"groupId" IS NULL'
    }),
    Index([
        "groupId",
        "blockeeId"
    ], {
        unique: true,
        where: '"groupId" IS NOT NULL'
    })
], CallBlocking);
